"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useDragSourceConnector = useDragSourceConnector;
var _internals = require("../../internals");
var _useDragDropManagerJs = require("../useDragDropManager.js");
var _vue = require("vue");
function useDragSourceConnector(dragSourceOptions, dragPreviewOptions) {
    var manager = (0, _useDragDropManagerJs).useDragDropManager();
    var connector = (0, _vue).computed(function() {
        return new _internals.SourceConnector((0, _vue).unref(manager).getBackend());
    });
    (0, _vue).watchEffect(function(onCleanup) {
        connector.value.dragSourceOptions = (0, _vue).unref(dragSourceOptions) || null;
        (0, _vue).unref(connector).reconnect();
        onCleanup(function() {
            connector.value.disconnectDragSource();
        });
    });
    (0, _vue).watchEffect(function(onCleanup) {
        connector.value.dragPreviewOptions = (0, _vue).unref(dragPreviewOptions) || null;
        (0, _vue).unref(connector).reconnect();
        onCleanup(function() {
            connector.value.disconnectDragPreview();
        });
    });
    return connector;
}
